# igloo Platform Monolithic Context Corpus > This file contains the entire documentation suite inlined for AI agents and LLMs. ## API Reference ### FILE: home/api_access Title: Access Category: API Reference ---------------------------------------- # Access API Reference API endpoints for managing access. ## AlgoPIN ### Create a Daily AlgoPIN `POST` `https://api.igloohome.co/home/devices/{deviceId}/algopin/daily` Returns a duration (Daily) AlgoPIN code. Allowable Range: 29 to 367 days (in days only, 29.5 days not allowed) #### Path Parameters | Parameter | Type | Required | | --- | --- | --- | | deviceId | string | Yes | #### Body Parameters Content-Type: `application/json` - **`variance`** `integer` *required* - Allowed values: `1`, `2`, `3` - **`startDate`** `string` *required*\ Date and time when the permission starts. Must be in format `YYYY-MM-DDTHH:00:00+hh:mm` (hour resolution only). **Note: The hour ('hh') on startDate and the hour ('hh') on endDate must match** - Example: `2022-01-01T12:00:00+08:00` - **`endDate`** `string` *required*\ Date and time when the permission ends. Must be in format `YYYY-MM-DDTHH:00:00+hh:mm` (hour resolution only). **Note: The hour ('hh') on startDate and the hour ('hh') on endDate must match** - Example: `2022-05-01T12:00:00+08:00` - **`accessName`** `string` *required*\ Name or short description of the access - Example: `Maintenance guy` #### Request Example ```bash curl -X POST "https://api.igloohome.co/home/devices/{deviceId}/algopin/daily" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -d '{ "accessName": "value", "endDate": "value", "startDate": "value", "variance": "value" }' ``` ```go package main import ( "bytes" "fmt" "io" "net/http" ) func main() { url := "https://api.igloohome.co/home/devices/{deviceId}/algopin/daily" payload := []byte(`{ "accessName": "value", "endDate": "value", "startDate": "value", "variance": "value" }`) req, _ := http.NewRequest("POST", url, bytes.NewBuffer(payload)) req.Header.Set("Content-Type", "application/json") req.Header.Set("Authorization", "Bearer YOUR_ACCESS_TOKEN") req.Header.Set("Accept", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(string(body)) } ``` ```javascript const res = await fetch("https://api.igloohome.co/home/devices/{deviceId}/algopin/daily", { method: "POST", headers: { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json", "Content-Type": "application/json" }, body: JSON.stringify({ "accessName": "value", "endDate": "value", "startDate": "value", "variance": "value" }) }); const data = await res.json(); console.log(data); ``` ```python import requests url = "https://api.igloohome.co/home/devices/{deviceId}/algopin/daily" headers = { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } payload = { "accessName": "value", "endDate": "value", "startDate": "value", "variance": "value" } response = requests.post(url, headers=headers, json=payload) print(response.json()) ``` ```php "https://api.igloohome.co/home/devices/{deviceId}/algopin/daily", CURLOPT_RETURNTRANSFER => true, CURLOPT_CUSTOMREQUEST => "POST", CURLOPT_HTTPHEADER => [ "Authorization: Bearer YOUR_ACCESS_TOKEN", "Accept: application/json", "Content-Type: application/json" ], CURLOPT_POSTFIELDS => json_encode([ "accessName" => "value", "endDate" => "value", "startDate" => "value", "variance" => "value" ]) ]); $response = curl_exec($curl); curl_close($curl); echo $response; ``` ```kotlin val client = OkHttpClient() val mediaType = "application/json".toMediaType() val body = """ { "accessName": "value", "endDate": "value", "startDate": "value", "variance": "value" } """.trimIndent().toRequestBody(mediaType) val request = Request.Builder() .url("https://api.igloohome.co/home/devices/{deviceId}/algopin/daily") .method("POST", body) .addHeader("Authorization", "Bearer YOUR_ACCESS_TOKEN") .addHeader("Accept", "application/json") .addHeader("Content-Type", "application/json") .build() val response = client.newCall(request).execute() println(response.body?.string()) ``` ```swift import Foundation var request = URLRequest(url: URL(string: "https://api.igloohome.co/home/devices/{deviceId}/algopin/daily")!) request.httpMethod = "POST" request.setValue("Bearer YOUR_ACCESS_TOKEN", forHTTPHeaderField: "Authorization") request.setValue("application/json", forHTTPHeaderField: "Accept") request.setValue("application/json", forHTTPHeaderField: "Content-Type") let payload: [String: Any] = [ "accessName": "value", "endDate": "value", "startDate": "value", "variance": "value" ] request.httpBody = try? JSONSerialization.data(withJSONObject: payload) let task = URLSession.shared.dataTask(with: request) { data, response, error in if let data = data { print(String(data: data, encoding: .utf8) ?? "") } } task.resume() ``` #### Responses `200 OK` `400 Bad Request` `401 Unauthorized, invalid or expired authorization token` `402 Response` `403 Forbidden, accessToken scope must contain 'igloohomeapi/algopin-daily'` `404 '{ message: 'not found device' }'` `409 Conflict. The device's property record is missing a timezone (data integrity guard).` `415 Unsupported Media Type` `418 '{ error: 'this device type does not support the feature.' }'. The device SKU does not support AlgoPIN codes.` `500 Internal Server Error` **Response body — `200`:** - **`pin`** `string` - Example: `4642226` - **`pinId`** `string` - Example: `CC0035C33E9B103A` **Response body — `400`:** - **`error`** `string` **Response body — `402`:** - **`error`** `string` **Response body — `404`:** - **`message`** `string` **Response body — `409`:** - **`message`** `string` **Response body — `418`:** - **`error`** `string` **Example response — `200`:** ```json { "pin": "7541869", "pinId": "EE4421C77G9F512D" } ``` **Example response — `400`:** ```json { "error": "'accessName' is required" } ``` **Example response — `402`:** ```json { "error": "30 days igloohome API trial has ended" } ``` **Example response — `404`:** ```json { "message": "not found device" } ``` **Example response — `409`:** ```json { "message": "timezone is not found on property" } ``` **Example response — `418`:** ```json { "error": "this device type does not support the feature." } ``` ### Create an Hourly AlgoPIN `POST` `https://api.igloohome.co/home/devices/{deviceId}/algopin/hourly` Returns a duration (Hourly) AlgoPIN code. Allowable Range: 1 to 672 hours #### Path Parameters | Parameter | Type | Required | | --- | --- | --- | | deviceId | string | Yes | #### Body Parameters Content-Type: `application/json` - **`variance`** `integer` *required* - Allowed values: `1`, `2`, `3` - **`startDate`** `string` *required*\ Date and time when the permission starts. Must be in format `YYYY-MM-DDTHH:00:00+hh:mm` (hour resolution only). May be up to 1 hour in the past. - Example: `2022-01-01T14:00:00+08:00` - **`endDate`** `string` *required*\ Date and time when the permission ends. Must be in format `YYYY-MM-DDTHH:00:00+hh:mm` (hour resolution only). **Maximum Value: startDate + 672 hours** - Example: `2022-01-02T12:00:00+08:00` - **`accessName`** `string` *required*\ Name or short description of the access - Example: `Maintenance guy` #### Request Example ```bash curl -X POST "https://api.igloohome.co/home/devices/{deviceId}/algopin/hourly" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -d '{ "accessName": "value", "endDate": "value", "startDate": "value", "variance": "value" }' ``` ```go package main import ( "bytes" "fmt" "io" "net/http" ) func main() { url := "https://api.igloohome.co/home/devices/{deviceId}/algopin/hourly" payload := []byte(`{ "accessName": "value", "endDate": "value", "startDate": "value", "variance": "value" }`) req, _ := http.NewRequest("POST", url, bytes.NewBuffer(payload)) req.Header.Set("Content-Type", "application/json") req.Header.Set("Authorization", "Bearer YOUR_ACCESS_TOKEN") req.Header.Set("Accept", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(string(body)) } ``` ```javascript const res = await fetch("https://api.igloohome.co/home/devices/{deviceId}/algopin/hourly", { method: "POST", headers: { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json", "Content-Type": "application/json" }, body: JSON.stringify({ "accessName": "value", "endDate": "value", "startDate": "value", "variance": "value" }) }); const data = await res.json(); console.log(data); ``` ```python import requests url = "https://api.igloohome.co/home/devices/{deviceId}/algopin/hourly" headers = { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } payload = { "accessName": "value", "endDate": "value", "startDate": "value", "variance": "value" } response = requests.post(url, headers=headers, json=payload) print(response.json()) ``` ```php "https://api.igloohome.co/home/devices/{deviceId}/algopin/hourly", CURLOPT_RETURNTRANSFER => true, CURLOPT_CUSTOMREQUEST => "POST", CURLOPT_HTTPHEADER => [ "Authorization: Bearer YOUR_ACCESS_TOKEN", "Accept: application/json", "Content-Type: application/json" ], CURLOPT_POSTFIELDS => json_encode([ "accessName" => "value", "endDate" => "value", "startDate" => "value", "variance" => "value" ]) ]); $response = curl_exec($curl); curl_close($curl); echo $response; ``` ```kotlin val client = OkHttpClient() val mediaType = "application/json".toMediaType() val body = """ { "accessName": "value", "endDate": "value", "startDate": "value", "variance": "value" } """.trimIndent().toRequestBody(mediaType) val request = Request.Builder() .url("https://api.igloohome.co/home/devices/{deviceId}/algopin/hourly") .method("POST", body) .addHeader("Authorization", "Bearer YOUR_ACCESS_TOKEN") .addHeader("Accept", "application/json") .addHeader("Content-Type", "application/json") .build() val response = client.newCall(request).execute() println(response.body?.string()) ``` ```swift import Foundation var request = URLRequest(url: URL(string: "https://api.igloohome.co/home/devices/{deviceId}/algopin/hourly")!) request.httpMethod = "POST" request.setValue("Bearer YOUR_ACCESS_TOKEN", forHTTPHeaderField: "Authorization") request.setValue("application/json", forHTTPHeaderField: "Accept") request.setValue("application/json", forHTTPHeaderField: "Content-Type") let payload: [String: Any] = [ "accessName": "value", "endDate": "value", "startDate": "value", "variance": "value" ] request.httpBody = try? JSONSerialization.data(withJSONObject: payload) let task = URLSession.shared.dataTask(with: request) { data, response, error in if let data = data { print(String(data: data, encoding: .utf8) ?? "") } } task.resume() ``` #### Responses `200 OK` `400 Bad Request` `401 Unauthorized, invalid or expired authorization token` `402 Response` `403 Forbidden, accessToken scope must contain 'igloohomeapi/algopin-hourly'` `404 '{ message: 'not found device' }'` `409 Conflict. The device's property record is missing a timezone (data integrity guard).` `415 Unsupported Media Type` `418 '{ error: 'this device type does not support the feature.' }'. The device SKU does not support AlgoPIN codes.` `500 Internal Server Error` **Response body — `200`:** - **`pin`** `string` - Example: `4642226` - **`pinId`** `string` - Example: `CC0035C33E9B103A` **Response body — `400`:** - **`error`** `string` **Response body — `402`:** - **`error`** `string` **Response body — `404`:** - **`message`** `string` **Response body — `409`:** - **`message`** `string` **Response body — `418`:** - **`error`** `string` **Example response — `200`:** ```json { "pin": "5729314", "pinId": "AA9876B22D5E405C" } ``` **Example response — `400`:** ```json { "error": "'accessName' is required" } ``` **Example response — `402`:** ```json { "error": "30 days igloohome API trial has ended" } ``` **Example response — `404`:** ```json { "message": "not found device" } ``` **Example response — `409`:** ```json { "message": "timezone is not found on property" } ``` **Example response — `418`:** ```json { "error": "this device type does not support the feature." } ``` ### Create a One-Time AlgoPIN `POST` `https://api.igloohome.co/home/devices/{deviceId}/algopin/onetime` Returns a one-time AlgoPIN code (OTP). #### Path Parameters | Parameter | Type | Required | | --- | --- | --- | | deviceId | string | Yes | #### Body Parameters Content-Type: `application/json` - **`variance`** `integer` *required*\ 1–10. Values 6–10 require newer lock firmware; some older locks support them after a firmware update, otherwise they accept 1–5. - **`startDate`** `string` *required*\ Must be in format `YYYY-MM-DDTHH:00:00+hh:mm` (hour resolution only) and now or later. - Example: `2022-01-01T00:00:00+08:00` - **`accessName`** `string` *required* - Example: `Maintenance guy` #### Request Example ```bash curl -X POST "https://api.igloohome.co/home/devices/{deviceId}/algopin/onetime" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -d '{ "accessName": "value", "startDate": "value", "variance": "value" }' ``` ```go package main import ( "bytes" "fmt" "io" "net/http" ) func main() { url := "https://api.igloohome.co/home/devices/{deviceId}/algopin/onetime" payload := []byte(`{ "accessName": "value", "startDate": "value", "variance": "value" }`) req, _ := http.NewRequest("POST", url, bytes.NewBuffer(payload)) req.Header.Set("Content-Type", "application/json") req.Header.Set("Authorization", "Bearer YOUR_ACCESS_TOKEN") req.Header.Set("Accept", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(string(body)) } ``` ```javascript const res = await fetch("https://api.igloohome.co/home/devices/{deviceId}/algopin/onetime", { method: "POST", headers: { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json", "Content-Type": "application/json" }, body: JSON.stringify({ "accessName": "value", "startDate": "value", "variance": "value" }) }); const data = await res.json(); console.log(data); ``` ```python import requests url = "https://api.igloohome.co/home/devices/{deviceId}/algopin/onetime" headers = { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } payload = { "accessName": "value", "startDate": "value", "variance": "value" } response = requests.post(url, headers=headers, json=payload) print(response.json()) ``` ```php "https://api.igloohome.co/home/devices/{deviceId}/algopin/onetime", CURLOPT_RETURNTRANSFER => true, CURLOPT_CUSTOMREQUEST => "POST", CURLOPT_HTTPHEADER => [ "Authorization: Bearer YOUR_ACCESS_TOKEN", "Accept: application/json", "Content-Type: application/json" ], CURLOPT_POSTFIELDS => json_encode([ "accessName" => "value", "startDate" => "value", "variance" => "value" ]) ]); $response = curl_exec($curl); curl_close($curl); echo $response; ``` ```kotlin val client = OkHttpClient() val mediaType = "application/json".toMediaType() val body = """ { "accessName": "value", "startDate": "value", "variance": "value" } """.trimIndent().toRequestBody(mediaType) val request = Request.Builder() .url("https://api.igloohome.co/home/devices/{deviceId}/algopin/onetime") .method("POST", body) .addHeader("Authorization", "Bearer YOUR_ACCESS_TOKEN") .addHeader("Accept", "application/json") .addHeader("Content-Type", "application/json") .build() val response = client.newCall(request).execute() println(response.body?.string()) ``` ```swift import Foundation var request = URLRequest(url: URL(string: "https://api.igloohome.co/home/devices/{deviceId}/algopin/onetime")!) request.httpMethod = "POST" request.setValue("Bearer YOUR_ACCESS_TOKEN", forHTTPHeaderField: "Authorization") request.setValue("application/json", forHTTPHeaderField: "Accept") request.setValue("application/json", forHTTPHeaderField: "Content-Type") let payload: [String: Any] = [ "accessName": "value", "startDate": "value", "variance": "value" ] request.httpBody = try? JSONSerialization.data(withJSONObject: payload) let task = URLSession.shared.dataTask(with: request) { data, response, error in if let data = data { print(String(data: data, encoding: .utf8) ?? "") } } task.resume() ``` #### Responses `200 OK` `400 Bad Request` `401 Unauthorized, invalid or expired authorization token` `402 Response` `403 Forbidden, accessToken scope must contain 'igloohomeapi/algopin-onetime'` `404 '{ message: 'not found device' }'` `409 Conflict. The device's property record is missing a timezone (data integrity guard).` `415 Unsupported Media Type` `418 '{ error: 'this device type does not support the feature.' }'. The device SKU does not support AlgoPIN codes.` `500 Internal Server Error` **Response body — `200`:** - **`pin`** `string` - Example: `4642226` - **`pinId`** `string` - Example: `CC0035C33E9B103A` **Response body — `400`:** - **`error`** `string` **Response body — `402`:** - **`error`** `string` **Response body — `404`:** - **`message`** `string` **Response body — `409`:** - **`message`** `string` **Response body — `418`:** - **`error`** `string` **Example response — `200`:** ```json { "pin": "4642226", "pinId": "CC0035C33E9B103A" } ``` **Example response — `400`:** ```json { "error": "'accessName' is required" } ``` **Example response — `402`:** ```json { "error": "30 days igloohome API trial has ended" } ``` **Example response — `404`:** ```json { "message": "not found device" } ``` **Example response — `409`:** ```json { "message": "timezone is not found on property" } ``` **Example response — `418`:** ```json { "error": "this device type does not support the feature." } ``` ### Create a Passage AlgoPIN `POST` `https://api.igloohome.co/home/devices/{deviceId}/algopin/passage` Allows unlock with AlgoPIN and keeps the lock unlocked for the duration given in the request body. Supports newer devices with the latest firmware only. #### Path Parameters | Parameter | Type | Required | | --- | --- | --- | | deviceId | string | Yes | #### Body Parameters Content-Type: `application/json` - **`variance`** `integer` *required* - Allowed values: `1` - **`startDate`** `string` *required*\ Date and time when the permission starts. Must be in format `YYYY-MM-DDTHH:00:00+hh:mm` (hour resolution only). The PIN is valid from `startDate` for `durationHours` hours. - Example: `2022-01-01T12:00:00+08:00` - **`durationHours`** `integer` *required*\ Must be between 1 and 12 hours - **`accessName`** `string` *required*\ Name or short description of the access - Example: `Maintenance guy` #### Request Example ```bash curl -X POST "https://api.igloohome.co/home/devices/{deviceId}/algopin/passage" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -d '{ "accessName": "value", "durationHours": "value", "startDate": "value", "variance": "value" }' ``` ```go package main import ( "bytes" "fmt" "io" "net/http" ) func main() { url := "https://api.igloohome.co/home/devices/{deviceId}/algopin/passage" payload := []byte(`{ "accessName": "value", "durationHours": "value", "startDate": "value", "variance": "value" }`) req, _ := http.NewRequest("POST", url, bytes.NewBuffer(payload)) req.Header.Set("Content-Type", "application/json") req.Header.Set("Authorization", "Bearer YOUR_ACCESS_TOKEN") req.Header.Set("Accept", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(string(body)) } ``` ```javascript const res = await fetch("https://api.igloohome.co/home/devices/{deviceId}/algopin/passage", { method: "POST", headers: { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json", "Content-Type": "application/json" }, body: JSON.stringify({ "accessName": "value", "durationHours": "value", "startDate": "value", "variance": "value" }) }); const data = await res.json(); console.log(data); ``` ```python import requests url = "https://api.igloohome.co/home/devices/{deviceId}/algopin/passage" headers = { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } payload = { "accessName": "value", "durationHours": "value", "startDate": "value", "variance": "value" } response = requests.post(url, headers=headers, json=payload) print(response.json()) ``` ```php "https://api.igloohome.co/home/devices/{deviceId}/algopin/passage", CURLOPT_RETURNTRANSFER => true, CURLOPT_CUSTOMREQUEST => "POST", CURLOPT_HTTPHEADER => [ "Authorization: Bearer YOUR_ACCESS_TOKEN", "Accept: application/json", "Content-Type: application/json" ], CURLOPT_POSTFIELDS => json_encode([ "accessName" => "value", "durationHours" => "value", "startDate" => "value", "variance" => "value" ]) ]); $response = curl_exec($curl); curl_close($curl); echo $response; ``` ```kotlin val client = OkHttpClient() val mediaType = "application/json".toMediaType() val body = """ { "accessName": "value", "durationHours": "value", "startDate": "value", "variance": "value" } """.trimIndent().toRequestBody(mediaType) val request = Request.Builder() .url("https://api.igloohome.co/home/devices/{deviceId}/algopin/passage") .method("POST", body) .addHeader("Authorization", "Bearer YOUR_ACCESS_TOKEN") .addHeader("Accept", "application/json") .addHeader("Content-Type", "application/json") .build() val response = client.newCall(request).execute() println(response.body?.string()) ``` ```swift import Foundation var request = URLRequest(url: URL(string: "https://api.igloohome.co/home/devices/{deviceId}/algopin/passage")!) request.httpMethod = "POST" request.setValue("Bearer YOUR_ACCESS_TOKEN", forHTTPHeaderField: "Authorization") request.setValue("application/json", forHTTPHeaderField: "Accept") request.setValue("application/json", forHTTPHeaderField: "Content-Type") let payload: [String: Any] = [ "accessName": "value", "durationHours": "value", "startDate": "value", "variance": "value" ] request.httpBody = try? JSONSerialization.data(withJSONObject: payload) let task = URLSession.shared.dataTask(with: request) { data, response, error in if let data = data { print(String(data: data, encoding: .utf8) ?? "") } } task.resume() ``` #### Responses `200 OK` `400 Bad Request` `401 Unauthorized, invalid or expired authorization token` `402 Response` `404 '{ message: 'not found device' }'` `409 Conflict. The device's property record is missing a timezone (data integrity guard).` `415 Unsupported Media Type` `422 '{ error: 'this device does not support passage PIN' }'. The device does not support passage AlgoPIN codes.` `500 Internal Server Error` **Response body — `200`:** - **`pin`** `string` - Example: `4642226` - **`pinId`** `string` - Example: `CC0035C33E9B103A` **Response body — `400`:** - **`error`** `string` **Response body — `402`:** - **`error`** `string` **Response body — `404`:** - **`message`** `string` **Response body — `409`:** - **`message`** `string` **Response body — `422`:** - **`error`** `string` **Example response — `200`:** ```json { "pin": "7541869", "pinId": "EE4421C77G9F512D" } ``` **Example response — `400`:** ```json { "error": "'accessName' is required" } ``` **Example response — `402`:** ```json { "error": "30 days igloohome API trial has ended" } ``` **Example response — `404`:** ```json { "message": "not found device" } ``` **Example response — `409`:** ```json { "message": "timezone is not found on property" } ``` **Example response — `422`:** ```json { "error": "this device does not support passage PIN" } ``` ### Create a Permanent AlgoPIN `POST` `https://api.igloohome.co/home/devices/{deviceId}/algopin/permanent` Returns a permanent AlgoPIN code. #### Path Parameters | Parameter | Type | Required | | --- | --- | --- | | deviceId | string | Yes | #### Body Parameters Content-Type: `application/json` - **`variance`** `integer` *required*\ 1–10. Values 6–10 require newer lock firmware; some older locks support them after a firmware update, otherwise they accept 1–5. - **`startDate`** `string` *required*\ Must be in format `YYYY-MM-DDTHH:00:00+hh:mm` (hour resolution only) and now or later. - Example: `2022-01-01T00:00:00+08:00` - **`accessName`** `string` *required* - Example: `Maintenance guy` #### Request Example ```bash curl -X POST "https://api.igloohome.co/home/devices/{deviceId}/algopin/permanent" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -d '{ "accessName": "value", "startDate": "value", "variance": "value" }' ``` ```go package main import ( "bytes" "fmt" "io" "net/http" ) func main() { url := "https://api.igloohome.co/home/devices/{deviceId}/algopin/permanent" payload := []byte(`{ "accessName": "value", "startDate": "value", "variance": "value" }`) req, _ := http.NewRequest("POST", url, bytes.NewBuffer(payload)) req.Header.Set("Content-Type", "application/json") req.Header.Set("Authorization", "Bearer YOUR_ACCESS_TOKEN") req.Header.Set("Accept", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(string(body)) } ``` ```javascript const res = await fetch("https://api.igloohome.co/home/devices/{deviceId}/algopin/permanent", { method: "POST", headers: { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json", "Content-Type": "application/json" }, body: JSON.stringify({ "accessName": "value", "startDate": "value", "variance": "value" }) }); const data = await res.json(); console.log(data); ``` ```python import requests url = "https://api.igloohome.co/home/devices/{deviceId}/algopin/permanent" headers = { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } payload = { "accessName": "value", "startDate": "value", "variance": "value" } response = requests.post(url, headers=headers, json=payload) print(response.json()) ``` ```php "https://api.igloohome.co/home/devices/{deviceId}/algopin/permanent", CURLOPT_RETURNTRANSFER => true, CURLOPT_CUSTOMREQUEST => "POST", CURLOPT_HTTPHEADER => [ "Authorization: Bearer YOUR_ACCESS_TOKEN", "Accept: application/json", "Content-Type: application/json" ], CURLOPT_POSTFIELDS => json_encode([ "accessName" => "value", "startDate" => "value", "variance" => "value" ]) ]); $response = curl_exec($curl); curl_close($curl); echo $response; ``` ```kotlin val client = OkHttpClient() val mediaType = "application/json".toMediaType() val body = """ { "accessName": "value", "startDate": "value", "variance": "value" } """.trimIndent().toRequestBody(mediaType) val request = Request.Builder() .url("https://api.igloohome.co/home/devices/{deviceId}/algopin/permanent") .method("POST", body) .addHeader("Authorization", "Bearer YOUR_ACCESS_TOKEN") .addHeader("Accept", "application/json") .addHeader("Content-Type", "application/json") .build() val response = client.newCall(request).execute() println(response.body?.string()) ``` ```swift import Foundation var request = URLRequest(url: URL(string: "https://api.igloohome.co/home/devices/{deviceId}/algopin/permanent")!) request.httpMethod = "POST" request.setValue("Bearer YOUR_ACCESS_TOKEN", forHTTPHeaderField: "Authorization") request.setValue("application/json", forHTTPHeaderField: "Accept") request.setValue("application/json", forHTTPHeaderField: "Content-Type") let payload: [String: Any] = [ "accessName": "value", "startDate": "value", "variance": "value" ] request.httpBody = try? JSONSerialization.data(withJSONObject: payload) let task = URLSession.shared.dataTask(with: request) { data, response, error in if let data = data { print(String(data: data, encoding: .utf8) ?? "") } } task.resume() ``` #### Responses `200 OK` `400 Bad Request` `401 Unauthorized, invalid or expired authorization token` `402 Response` `403 Forbidden, accessToken scope must contain 'igloohomeapi/algopin-permanent'` `404 '{ message: 'not found device' }'` `409 Conflict. The device's property record is missing a timezone (data integrity guard).` `415 Unsupported Media Type` `418 '{ error: 'this device type does not support the feature.' }'. The device SKU does not support AlgoPIN codes.` `500 Internal Server Error` **Response body — `200`:** - **`pin`** `string` - Example: `4642226` - **`pinId`** `string` - Example: `CC0035C33E9B103A` **Response body — `400`:** - **`error`** `string` **Response body — `402`:** - **`error`** `string` **Response body — `404`:** - **`message`** `string` **Response body — `409`:** - **`message`** `string` **Response body — `418`:** - **`error`** `string` **Example response — `200`:** ```json { "pin": "8137492", "pinId": "DD1246E44F0C214B" } ``` **Example response — `400`:** ```json { "error": "'accessName' is required" } ``` **Example response — `402`:** ```json { "error": "30 days igloohome API trial has ended" } ``` **Example response — `404`:** ```json { "message": "not found device" } ``` **Example response — `409`:** ```json { "message": "timezone is not found on property" } ``` **Example response — `418`:** ```json { "error": "this device type does not support the feature." } ``` ## eKey ### Generate eKey `POST` `https://api.igloohome.co/home/devices/{deviceId}/ekey` Create an eKey. #### Path Parameters | Parameter | Type | Required | | --- | --- | --- | | deviceId | string | Yes | #### Body Parameters Content-Type: `application/json` - **`startDate`** `string` *required*\ User is able to control the lock starting this date. Seconds must be `:00` (minute resolution). - Example: `2021-01-03T12:00:00+08:00` - **`endDate`** `string` *required*\ User is unable to control the lock starting this date. Seconds must be `:00` (minute resolution), and must be after `startDate`. - Example: `2021-11-03T12:00:00+08:00` - **`permissions`** `array of string` *required*\ List of permissions to grant on this eKey. Required. There is no default, although the field can look optional. - Example: `["UNLOCK"]` #### Request Example ```bash curl -X POST "https://api.igloohome.co/home/devices/{deviceId}/ekey" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -d '{ "endDate": "value", "permissions": "value", "startDate": "value" }' ``` ```go package main import ( "bytes" "fmt" "io" "net/http" ) func main() { url := "https://api.igloohome.co/home/devices/{deviceId}/ekey" payload := []byte(`{ "endDate": "value", "permissions": "value", "startDate": "value" }`) req, _ := http.NewRequest("POST", url, bytes.NewBuffer(payload)) req.Header.Set("Content-Type", "application/json") req.Header.Set("Authorization", "Bearer YOUR_ACCESS_TOKEN") req.Header.Set("Accept", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(string(body)) } ``` ```javascript const res = await fetch("https://api.igloohome.co/home/devices/{deviceId}/ekey", { method: "POST", headers: { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json", "Content-Type": "application/json" }, body: JSON.stringify({ "endDate": "value", "permissions": "value", "startDate": "value" }) }); const data = await res.json(); console.log(data); ``` ```python import requests url = "https://api.igloohome.co/home/devices/{deviceId}/ekey" headers = { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } payload = { "endDate": "value", "permissions": "value", "startDate": "value" } response = requests.post(url, headers=headers, json=payload) print(response.json()) ``` ```php "https://api.igloohome.co/home/devices/{deviceId}/ekey", CURLOPT_RETURNTRANSFER => true, CURLOPT_CUSTOMREQUEST => "POST", CURLOPT_HTTPHEADER => [ "Authorization: Bearer YOUR_ACCESS_TOKEN", "Accept: application/json", "Content-Type: application/json" ], CURLOPT_POSTFIELDS => json_encode([ "endDate" => "value", "permissions" => "value", "startDate" => "value" ]) ]); $response = curl_exec($curl); curl_close($curl); echo $response; ``` ```kotlin val client = OkHttpClient() val mediaType = "application/json".toMediaType() val body = """ { "endDate": "value", "permissions": "value", "startDate": "value" } """.trimIndent().toRequestBody(mediaType) val request = Request.Builder() .url("https://api.igloohome.co/home/devices/{deviceId}/ekey") .method("POST", body) .addHeader("Authorization", "Bearer YOUR_ACCESS_TOKEN") .addHeader("Accept", "application/json") .addHeader("Content-Type", "application/json") .build() val response = client.newCall(request).execute() println(response.body?.string()) ``` ```swift import Foundation var request = URLRequest(url: URL(string: "https://api.igloohome.co/home/devices/{deviceId}/ekey")!) request.httpMethod = "POST" request.setValue("Bearer YOUR_ACCESS_TOKEN", forHTTPHeaderField: "Authorization") request.setValue("application/json", forHTTPHeaderField: "Accept") request.setValue("application/json", forHTTPHeaderField: "Content-Type") let payload: [String: Any] = [ "endDate": "value", "permissions": "value", "startDate": "value" ] request.httpBody = try? JSONSerialization.data(withJSONObject: payload) let task = URLSession.shared.dataTask(with: request) { data, response, error in if let data = data { print(String(data: data, encoding: .utf8) ?? "") } } task.resume() ``` #### Responses `200 OK` `400 Bad Request` `401 Unauthorized, invalid or expired authorization token` `402 Response` `403 Forbidden, accessToken scope must contain 'igloohomeapi/create-ekey-access'` `404 '{ message: 'not found device' }' or '{ message: 'not found property' }'` `409 Response` `415 Unsupported Media Type` `500 Internal Server Error` **Response body — `200`:** - **`keyId`** `integer` - **`bluetoothGuestKey`** `string` **Response body — `402`:** - **`error`** `string` **Response body — `404`:** - **`message`** `string` **Example response — `200`:** ```json { "bluetoothGuestKey": "xNXdtaE5DcjBzbktXZWc1Q3d2SFd0RVU5T2swWjRmQjRkRjdhczlONEE9PQ==", "keyId": 12847 } ``` **Example response — `400`:** ```json "configuration lock issue" ``` **Example response — `402`:** ```json { "error": "30 days igloohome API trial has ended" } ``` **Example response — `404`:** ```json { "message": "not found device" } ``` **Example response — `409`:** ```json "invalid.generate.ekey" ``` ## iglooKey ### Create iglooKey Token `POST` `https://api.igloohome.co/home/pass` Creates a shareable iglooKey access token that supports both online and offline unlock for one or more devices. #### Body Parameters Content-Type: `application/json` - **`deviceIds`** `array of string` *required* - **`label`** `string` *required* - **`endsAt`** `string` *required*\ Must be in the future - **`startsAt`** `string`\ Must be on or before `endsAt` - **`activationWindowSeconds`** `integer`\ If set, the token must be activated within this many seconds of `startsAt` (or now); the resulting deadline must not exceed `endsAt`. - **`offlineAccessSeconds`** `integer`\ Grants offline access validity, in seconds (max 24 hours) #### Request Example ```bash curl -X POST "https://api.igloohome.co/home/pass" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -d '{ "activationWindowSeconds": "value", "deviceIds": "value", "endsAt": "value", "label": "value", "offlineAccessSeconds": "value", "startsAt": "value" }' ``` ```go package main import ( "bytes" "fmt" "io" "net/http" ) func main() { url := "https://api.igloohome.co/home/pass" payload := []byte(`{ "activationWindowSeconds": "value", "deviceIds": "value", "endsAt": "value", "label": "value", "offlineAccessSeconds": "value", "startsAt": "value" }`) req, _ := http.NewRequest("POST", url, bytes.NewBuffer(payload)) req.Header.Set("Content-Type", "application/json") req.Header.Set("Authorization", "Bearer YOUR_ACCESS_TOKEN") req.Header.Set("Accept", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(string(body)) } ``` ```javascript const res = await fetch("https://api.igloohome.co/home/pass", { method: "POST", headers: { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json", "Content-Type": "application/json" }, body: JSON.stringify({ "activationWindowSeconds": "value", "deviceIds": "value", "endsAt": "value", "label": "value", "offlineAccessSeconds": "value", "startsAt": "value" }) }); const data = await res.json(); console.log(data); ``` ```python import requests url = "https://api.igloohome.co/home/pass" headers = { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } payload = { "activationWindowSeconds": "value", "deviceIds": "value", "endsAt": "value", "label": "value", "offlineAccessSeconds": "value", "startsAt": "value" } response = requests.post(url, headers=headers, json=payload) print(response.json()) ``` ```php "https://api.igloohome.co/home/pass", CURLOPT_RETURNTRANSFER => true, CURLOPT_CUSTOMREQUEST => "POST", CURLOPT_HTTPHEADER => [ "Authorization: Bearer YOUR_ACCESS_TOKEN", "Accept: application/json", "Content-Type: application/json" ], CURLOPT_POSTFIELDS => json_encode([ "activationWindowSeconds" => "value", "deviceIds" => "value", "endsAt" => "value", "label" => "value", "offlineAccessSeconds" => "value", "startsAt" => "value" ]) ]); $response = curl_exec($curl); curl_close($curl); echo $response; ``` ```kotlin val client = OkHttpClient() val mediaType = "application/json".toMediaType() val body = """ { "activationWindowSeconds": "value", "deviceIds": "value", "endsAt": "value", "label": "value", "offlineAccessSeconds": "value", "startsAt": "value" } """.trimIndent().toRequestBody(mediaType) val request = Request.Builder() .url("https://api.igloohome.co/home/pass") .method("POST", body) .addHeader("Authorization", "Bearer YOUR_ACCESS_TOKEN") .addHeader("Accept", "application/json") .addHeader("Content-Type", "application/json") .build() val response = client.newCall(request).execute() println(response.body?.string()) ``` ```swift import Foundation var request = URLRequest(url: URL(string: "https://api.igloohome.co/home/pass")!) request.httpMethod = "POST" request.setValue("Bearer YOUR_ACCESS_TOKEN", forHTTPHeaderField: "Authorization") request.setValue("application/json", forHTTPHeaderField: "Accept") request.setValue("application/json", forHTTPHeaderField: "Content-Type") let payload: [String: Any] = [ "activationWindowSeconds": "value", "deviceIds": "value", "endsAt": "value", "label": "value", "offlineAccessSeconds": "value", "startsAt": "value" ] request.httpBody = try? JSONSerialization.data(withJSONObject: payload) let task = URLSession.shared.dataTask(with: request) { data, response, error in if let data = data { print(String(data: data, encoding: .utf8) ?? "") } } task.resume() ``` #### Responses `201 Created` `400 Bad Request` `401 Unauthorized, invalid or expired authorization token` `402 Response` `403 Forbidden` `404 Not Found` `415 Unsupported Media Type` `422 '{ message: 'device type not supported for iglooKey', excludedIds: string[] }'` `500 Internal Server Error` `502 Response` `503 Response` **Response body — `201`:** - **`shareableUrl`** `string` - **`id`** `string` - **`type`** `string`\ Token type, `TOKEN_TYPE_HYBRID`. - **`endsAt`** `string` - **`createdAt`** `string` - **`startsAt`** `string` - **`activationDeadline`** `string` **Response body — `400`:** - **`error`** `string` - **`message`** `string` **Response body — `402`:** - **`error`** `string` **Response body — `404`:** - **`message`** `string` - **`missingIds`** `array of string` **Example response — `201`:** ```json { "activationDeadline": "2025-09-15T11:00:00Z", "createdAt": "2025-09-08T14:30:45Z", "endsAt": "2025-12-31T23:59:59Z", "id": "lnk_abc123def456ghi789jkl012mno345", "shareableUrl": "https://igloodev.app.link/pass?token=lnk_abc123def456ghi789jkl012mno345", "startsAt": "2025-09-15T10:00:00Z", "type": "TOKEN_TYPE_HYBRID" } ``` **Example response — `400`:** ```json { "error": "\"endsAt\" must be in the future" } ``` **Example response — `402`:** ```json { "error": "30 days igloohome API trial has ended" } ``` **Example response — `404`:** ```json { "message": "device not found" } ``` ### Update iglooKey Token `PATCH` `https://api.igloohome.co/home/pass/{id}` Updates the validity window (`startsAt`/`endsAt`) of an existing iglooKey token. #### Path Parameters | Parameter | Type | Required | | --- | --- | --- | | id | string | Yes | #### Body Parameters Content-Type: `application/json` - **`startsAt`** `string`\ Must be in the future - **`endsAt`** `string`\ Must be in the future and after `startsAt` #### Request Example ```bash curl -X PATCH "https://api.igloohome.co/home/pass/{id}" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -d '{ "endsAt": "value", "startsAt": "value" }' ``` ```go package main import ( "bytes" "fmt" "io" "net/http" ) func main() { url := "https://api.igloohome.co/home/pass/{id}" payload := []byte(`{ "endsAt": "value", "startsAt": "value" }`) req, _ := http.NewRequest("PATCH", url, bytes.NewBuffer(payload)) req.Header.Set("Content-Type", "application/json") req.Header.Set("Authorization", "Bearer YOUR_ACCESS_TOKEN") req.Header.Set("Accept", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(string(body)) } ``` ```javascript const res = await fetch("https://api.igloohome.co/home/pass/{id}", { method: "PATCH", headers: { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json", "Content-Type": "application/json" }, body: JSON.stringify({ "endsAt": "value", "startsAt": "value" }) }); const data = await res.json(); console.log(data); ``` ```python import requests url = "https://api.igloohome.co/home/pass/{id}" headers = { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } payload = { "endsAt": "value", "startsAt": "value" } response = requests.patch(url, headers=headers, json=payload) print(response.json()) ``` ```php "https://api.igloohome.co/home/pass/{id}", CURLOPT_RETURNTRANSFER => true, CURLOPT_CUSTOMREQUEST => "PATCH", CURLOPT_HTTPHEADER => [ "Authorization: Bearer YOUR_ACCESS_TOKEN", "Accept: application/json", "Content-Type: application/json" ], CURLOPT_POSTFIELDS => json_encode([ "endsAt" => "value", "startsAt" => "value" ]) ]); $response = curl_exec($curl); curl_close($curl); echo $response; ``` ```kotlin val client = OkHttpClient() val mediaType = "application/json".toMediaType() val body = """ { "endsAt": "value", "startsAt": "value" } """.trimIndent().toRequestBody(mediaType) val request = Request.Builder() .url("https://api.igloohome.co/home/pass/{id}") .method("PATCH", body) .addHeader("Authorization", "Bearer YOUR_ACCESS_TOKEN") .addHeader("Accept", "application/json") .addHeader("Content-Type", "application/json") .build() val response = client.newCall(request).execute() println(response.body?.string()) ``` ```swift import Foundation var request = URLRequest(url: URL(string: "https://api.igloohome.co/home/pass/{id}")!) request.httpMethod = "PATCH" request.setValue("Bearer YOUR_ACCESS_TOKEN", forHTTPHeaderField: "Authorization") request.setValue("application/json", forHTTPHeaderField: "Accept") request.setValue("application/json", forHTTPHeaderField: "Content-Type") let payload: [String: Any] = [ "endsAt": "value", "startsAt": "value" ] request.httpBody = try? JSONSerialization.data(withJSONObject: payload) let task = URLSession.shared.dataTask(with: request) { data, response, error in if let data = data { print(String(data: data, encoding: .utf8) ?? "") } } task.resume() ``` #### Responses `200 OK` `400 Bad Request` `401 Unauthorized, invalid or expired authorization token` `402 Response` `403 Forbidden` `404 Not Found` `415 Unsupported Media Type` `500 Internal Server Error` `502 Response` `503 '{ message: 'failed to update iglooKey token' }' if the upstream linking service was unreachable.` **Response body — `200`:** - **`id`** `string` - **`type`** `string`\ Token type, `TOKEN_TYPE_HYBRID`. - **`endsAt`** `string` - **`startsAt`** `string` - **`activationDeadline`** `string` **Response body — `400`:** - **`error`** `string` - **`message`** `string` **Response body — `402`:** - **`error`** `string` **Response body — `404`:** - **`message`** `string` - **`missingIds`** `array of string` **Example response — `200`:** ```json { "activationDeadline": "2025-09-20T14:00:00Z", "endsAt": "2026-01-15T23:59:59Z", "id": "lnk_abc123def456ghi789jkl012mno345", "startsAt": "2025-09-20T12:00:00Z", "type": "TOKEN_TYPE_HYBRID" } ``` **Example response — `400`:** ```json { "error": "\"endsAt\" must be in the future" } ``` **Example response — `402`:** ```json { "error": "30 days igloohome API trial has ended" } ``` **Example response — `404`:** ```json { "message": "device not found" } ``` ### Revoke iglooKey Token `DELETE` `https://api.igloohome.co/home/pass/{id}` Revokes an existing iglooKey token. No request body. #### Path Parameters | Parameter | Type | Required | | --- | --- | --- | | id | string | Yes | #### Request Example ```bash curl -X DELETE "https://api.igloohome.co/home/pass/{id}" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "Accept: application/json" ``` ```go package main import ( "fmt" "io" "net/http" ) func main() { url := "https://api.igloohome.co/home/pass/{id}" req, _ := http.NewRequest("DELETE", url, nil) req.Header.Set("Authorization", "Bearer YOUR_ACCESS_TOKEN") req.Header.Set("Accept", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(string(body)) } ``` ```javascript const res = await fetch("https://api.igloohome.co/home/pass/{id}", { method: "DELETE", headers: { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } }); const data = await res.json(); console.log(data); ``` ```python import requests url = "https://api.igloohome.co/home/pass/{id}" headers = { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } response = requests.delete(url, headers=headers) print(response.json()) ``` ```php "https://api.igloohome.co/home/pass/{id}", CURLOPT_RETURNTRANSFER => true, CURLOPT_CUSTOMREQUEST => "DELETE", CURLOPT_HTTPHEADER => [ "Authorization: Bearer YOUR_ACCESS_TOKEN", "Accept: application/json" ] ]); $response = curl_exec($curl); curl_close($curl); echo $response; ``` ```kotlin val client = OkHttpClient() val request = Request.Builder() .url("https://api.igloohome.co/home/pass/{id}") .method("DELETE", null) .addHeader("Authorization", "Bearer YOUR_ACCESS_TOKEN") .addHeader("Accept", "application/json") .build() val response = client.newCall(request).execute() println(response.body?.string()) ``` ```swift import Foundation var request = URLRequest(url: URL(string: "https://api.igloohome.co/home/pass/{id}")!) request.httpMethod = "DELETE" request.setValue("Bearer YOUR_ACCESS_TOKEN", forHTTPHeaderField: "Authorization") request.setValue("application/json", forHTTPHeaderField: "Accept") let task = URLSession.shared.dataTask(with: request) { data, response, error in if let data = data { print(String(data: data, encoding: .utf8) ?? "") } } task.resume() ``` #### Responses `204 No Content` `400 Bad Request` `401 Unauthorized, invalid or expired authorization token` `402 Response` `403 Forbidden` `404 Not Found` `500 Internal Server Error` `502 '{ message: 'failed to revoke iglooKey token' }' if the upstream linking service returned a server error or an unrecognized status.` `503 '{ message: 'failed to revoke iglooKey token' }' if the upstream linking service was unreachable.` **Response body — `400`:** - **`error`** `string` - **`message`** `string` **Response body — `402`:** - **`error`** `string` **Response body — `404`:** - **`message`** `string` - **`missingIds`** `array of string` **Example response — `400`:** ```json { "error": "\"endsAt\" must be in the future" } ``` **Example response — `402`:** ```json { "error": "30 days igloohome API trial has ended" } ``` **Example response — `404`:** ```json { "message": "device not found" } ``` ### FILE: home/api_devices Title: Devices Category: API Reference ---------------------------------------- # Devices API Reference API endpoints for managing devices. ## Get Devices `GET` `https://api.igloohome.co/home/devices` Returns a list of devices paired to the account. Devices include locks, as well as non-lock devices. |Device Type| |--| |Lock| |Keypad| |Bridge| |Fob| ### Query Parameters - **`limit`** `number`\ Number of objects to return, from 1 to 300. Defaults to 100. - Constraints: `>= 1`, `<= 300` - Default: `100` - Example: `30` - **`cursor`** `string`\ The pagination cursor. `cursor` is a string ID that marks your place in the list. For instance, if you make a list request and receive 100 objects, with `nextCursor` of `2sThyA1jii6WmTo3j`, your next call can include `cursor=2sThyA1jii6WmTo3j` in order to fetch the next page of the list. - **`sort`** `string`\ Order in which to return objects. Defaults to `desc`. - Default: `desc` - Allowed values: `asc`, `desc` ### Request Example ```bash curl -X GET "https://api.igloohome.co/home/devices?limit=value&cursor=value&sort=value" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "Accept: application/json" ``` ```go package main import ( "fmt" "io" "net/http" ) func main() { url := "https://api.igloohome.co/home/devices?limit=value&cursor=value&sort=value" req, _ := http.NewRequest("GET", url, nil) req.Header.Set("Authorization", "Bearer YOUR_ACCESS_TOKEN") req.Header.Set("Accept", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(string(body)) } ``` ```javascript const res = await fetch("https://api.igloohome.co/home/devices?limit=value&cursor=value&sort=value", { method: "GET", headers: { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } }); const data = await res.json(); console.log(data); ``` ```python import requests url = "https://api.igloohome.co/home/devices" headers = { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } params = { "limit": "value", "cursor": "value", "sort": "value" } response = requests.get(url, headers=headers, params=params) print(response.json()) ``` ```php "https://api.igloohome.co/home/devices?limit=value&cursor=value&sort=value", CURLOPT_RETURNTRANSFER => true, CURLOPT_CUSTOMREQUEST => "GET", CURLOPT_HTTPHEADER => [ "Authorization: Bearer YOUR_ACCESS_TOKEN", "Accept: application/json" ] ]); $response = curl_exec($curl); curl_close($curl); echo $response; ``` ```kotlin val client = OkHttpClient() val request = Request.Builder() .url("https://api.igloohome.co/home/devices?limit=value&cursor=value&sort=value") .method("GET", null) .addHeader("Authorization", "Bearer YOUR_ACCESS_TOKEN") .addHeader("Accept", "application/json") .build() val response = client.newCall(request).execute() println(response.body?.string()) ``` ```swift import Foundation var request = URLRequest(url: URL(string: "https://api.igloohome.co/home/devices?limit=value&cursor=value&sort=value")!) request.httpMethod = "GET" request.setValue("Bearer YOUR_ACCESS_TOKEN", forHTTPHeaderField: "Authorization") request.setValue("application/json", forHTTPHeaderField: "Accept") let task = URLSession.shared.dataTask(with: request) { data, response, error in if let data = data { print(String(data: data, encoding: .utf8) ?? "") } } task.resume() ``` ### Responses `200 OK` `400 Bad Request` `401 Unauthorized, invalid or expired authorization token` `402 Response` `403 Forbidden, accessToken scope must contain 'igloohomeapi/get-devices'` `500 Internal Server Error` **Response body — `200`:** - **`nextCursor`** `string`\ A string pointing to the next page of results. Empty string indicates you reached the end of the list - Example: `2sThyA1jii6WmTo3j` - **`payload`** `array of object`\ An array containing the return devices - **`id`** `string`\ Internal batch identifier of the device - Example: `2rqQx4Riasw3Rs6db01` - **`type`** `string`\ Device Type - Example: `Keypad` - **`deviceId`** `string`\ Unique Identifier of the device - Example: `EK1X013f300d` - **`deviceName`** `string`\ Name of the device - Example: `My keypad 1` - **`batteryLevel`** `integer`\ Battery level of the device - Example: `100` - **`pairedAt`** `string`\ Pairing date - Example: `2022-05-30T00:00:00+08:00` - **`homeId`** `array of string`\ Associated homes or properties. Populated as full property objects when you pass `expand=homeId`. - Example: `["2rqQx4Riasw3Rs6db"]` - **`linkedDevices`** `array of object`\ Device(s) linked to this device - Example: `[{"type":"Lock"},{"deviceId":"IGP102c1854a"}]` - **`id`** `string`\ Internal batch identifier of the linked device - **`type`** `string` - **`deviceId`** `string` **Response body — `400`:** - **`error`** `string` **Response body — `402`:** - **`error`** `string` **Example response — `200`:** ```json { "nextCursor": "22j3230ids0idsa0d", "payload": [ { "batteryLevel": 100, "deviceId": "EK1X013f300d", "deviceName": "Keypad", "homeId": [ "2rqQx4Riasw3Rs6db" ], "linkedDevices": [ { "deviceId": "IGP102c1854a", "type": "Lock" } ], "pairedAt": "2022-06-30T17:00:00+08:00", "type": "Keypad" } ] } ``` **Example response — `400`:** ```json { "error": "'cursor' cannot be empty string" } ``` **Example response — `402`:** ```json { "error": "30 days igloohome API trial has ended" } ``` ## Get Devices Supporting AlgoPIN `GET` `https://api.igloohome.co/home/devices/support-pins` Returns a list of devices paired to the account that support AlgoPIN codes. Same shape and filters as [Get Devices](/home/api_devices#get-devices), restricted to AlgoPIN-capable SKUs. ### Query Parameters - **`limit`** `number`\ Number of objects to return, from 1 to 300. Defaults to 100. - Constraints: `>= 1`, `<= 300` - Default: `100` - Example: `30` - **`cursor`** `string`\ The pagination cursor. `cursor` is a string ID that marks your place in the list. For instance, if you make a list request and receive 100 objects, with `nextCursor` of `2sThyA1jii6WmTo3j`, your next call can include `cursor=2sThyA1jii6WmTo3j` in order to fetch the next page of the list. - **`sort`** `string`\ Order in which to return objects. Defaults to `desc`. - Default: `desc` - Allowed values: `asc`, `desc` ### Request Example ```bash curl -X GET "https://api.igloohome.co/home/devices/support-pins?limit=value&cursor=value&sort=value" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "Accept: application/json" ``` ```go package main import ( "fmt" "io" "net/http" ) func main() { url := "https://api.igloohome.co/home/devices/support-pins?limit=value&cursor=value&sort=value" req, _ := http.NewRequest("GET", url, nil) req.Header.Set("Authorization", "Bearer YOUR_ACCESS_TOKEN") req.Header.Set("Accept", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(string(body)) } ``` ```javascript const res = await fetch("https://api.igloohome.co/home/devices/support-pins?limit=value&cursor=value&sort=value", { method: "GET", headers: { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } }); const data = await res.json(); console.log(data); ``` ```python import requests url = "https://api.igloohome.co/home/devices/support-pins" headers = { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } params = { "limit": "value", "cursor": "value", "sort": "value" } response = requests.get(url, headers=headers, params=params) print(response.json()) ``` ```php "https://api.igloohome.co/home/devices/support-pins?limit=value&cursor=value&sort=value", CURLOPT_RETURNTRANSFER => true, CURLOPT_CUSTOMREQUEST => "GET", CURLOPT_HTTPHEADER => [ "Authorization: Bearer YOUR_ACCESS_TOKEN", "Accept: application/json" ] ]); $response = curl_exec($curl); curl_close($curl); echo $response; ``` ```kotlin val client = OkHttpClient() val request = Request.Builder() .url("https://api.igloohome.co/home/devices/support-pins?limit=value&cursor=value&sort=value") .method("GET", null) .addHeader("Authorization", "Bearer YOUR_ACCESS_TOKEN") .addHeader("Accept", "application/json") .build() val response = client.newCall(request).execute() println(response.body?.string()) ``` ```swift import Foundation var request = URLRequest(url: URL(string: "https://api.igloohome.co/home/devices/support-pins?limit=value&cursor=value&sort=value")!) request.httpMethod = "GET" request.setValue("Bearer YOUR_ACCESS_TOKEN", forHTTPHeaderField: "Authorization") request.setValue("application/json", forHTTPHeaderField: "Accept") let task = URLSession.shared.dataTask(with: request) { data, response, error in if let data = data { print(String(data: data, encoding: .utf8) ?? "") } } task.resume() ``` ### Responses `200 OK` `400 Bad Request. Same validation as [Get Devices](/home/api_devices#get-devices).` `401 Unauthorized, invalid or expired authorization token` `402 Response` `403 Forbidden, accessToken scope must contain 'igloohomeapi/get-devices'` `500 Internal Server Error` **Response body — `200`:** - **`nextCursor`** `string`\ A string pointing to the next page of results. Empty string indicates you reached the end of the list - **`payload`** `array of object` - **`id`** `string` - **`type`** `string` - **`deviceId`** `string` - **`deviceName`** `string` - **`batteryLevel`** `integer` - **`pairedAt`** `string` - **`homeId`** `array of string` - **`linkedDevices`** `array of object` - **`id`** `string` - **`type`** `string` - **`deviceId`** `string` **Response body — `400`:** - **`error`** `string` **Response body — `402`:** - **`error`** `string` **Example response — `200`:** ```json { "nextCursor": "", "payload": [ { "batteryLevel": 87, "deviceId": "IGP102c1854a", "deviceName": "Front Door Lock", "homeId": [ "2rqQx4Riasw3Rs6db" ], "id": "2rqQx4Riasw3Rs6db01", "linkedDevices": [], "pairedAt": "2023-06-15T14:30:00+08:00", "type": "Lock" } ] } ``` **Example response — `400`:** ```json { "error": "'limit' must be between 1 to 300 inclusive" } ``` **Example response — `402`:** ```json { "error": "30 days igloohome API trial has ended" } ``` ## Get Device Details `GET` `https://api.igloohome.co/home/devices/{deviceId}` Returns device details. `lockStatus` is only populated for a `Lock` device that is linked to a bridge. `admin_key`/`lockRef` are only populated when the corresponding query params are passed. ### Path Parameters | Parameter | Type | Required | | --- | --- | --- | | deviceId | string | Yes | ### Request Example ```bash curl -X GET "https://api.igloohome.co/home/devices/{deviceId}" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "Accept: application/json" ``` ```go package main import ( "fmt" "io" "net/http" ) func main() { url := "https://api.igloohome.co/home/devices/{deviceId}" req, _ := http.NewRequest("GET", url, nil) req.Header.Set("Authorization", "Bearer YOUR_ACCESS_TOKEN") req.Header.Set("Accept", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(string(body)) } ``` ```javascript const res = await fetch("https://api.igloohome.co/home/devices/{deviceId}", { method: "GET", headers: { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } }); const data = await res.json(); console.log(data); ``` ```python import requests url = "https://api.igloohome.co/home/devices/{deviceId}" headers = { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } response = requests.get(url, headers=headers) print(response.json()) ``` ```php "https://api.igloohome.co/home/devices/{deviceId}", CURLOPT_RETURNTRANSFER => true, CURLOPT_CUSTOMREQUEST => "GET", CURLOPT_HTTPHEADER => [ "Authorization: Bearer YOUR_ACCESS_TOKEN", "Accept: application/json" ] ]); $response = curl_exec($curl); curl_close($curl); echo $response; ``` ```kotlin val client = OkHttpClient() val request = Request.Builder() .url("https://api.igloohome.co/home/devices/{deviceId}") .method("GET", null) .addHeader("Authorization", "Bearer YOUR_ACCESS_TOKEN") .addHeader("Accept", "application/json") .build() val response = client.newCall(request).execute() println(response.body?.string()) ``` ```swift import Foundation var request = URLRequest(url: URL(string: "https://api.igloohome.co/home/devices/{deviceId}")!) request.httpMethod = "GET" request.setValue("Bearer YOUR_ACCESS_TOKEN", forHTTPHeaderField: "Authorization") request.setValue("application/json", forHTTPHeaderField: "Accept") let task = URLSession.shared.dataTask(with: request) { data, response, error in if let data = data { print(String(data: data, encoding: .utf8) ?? "") } } task.resume() ``` ### Responses `200 OK` `401 Unauthorized, invalid or expired authorization token` `402 Response` `403 Forbidden, accessToken scope must contain 'igloohomeapi/get-devices'` `404 '{ message: 'not found device' }'` `409 Conflict. The device's property record is missing a timezone (data integrity guard). '{ message: 'timezone is not found on property' }'` `500 Internal Server Error` **Response body — `200`:** - **`id`** `string`\ Internal batch identifier of the device - Example: `2rqQx4Riasw3Rs6db01` - **`type`** `string`\ Device Type - Example: `Keypad` - **`deviceId`** `string`\ Unique Identifier of the device - Example: `EK1X013f300d` - **`deviceName`** `string`\ Name of the device - Example: `My keypad 1` - **`batteryLevel`** `integer`\ Battery level of the device - Example: `100` - **`pairedAt`** `string`\ Pairing date - Example: `2022-05-30T00:00:00+08:00` - **`lockStatus`** `string`\ Current lock status. Only populated for a `Lock` device that is linked to a bridge. - Example: `LOCKED` - **`homeId`** `array of string`\ Associated home/property(s) - Example: `["2rqQx4Riasw3Rs6db"]` - **`linkedDevices`** `array of object`\ Device(s) linked to this device - Example: `[{"type":"Lock"},{"deviceId":"IGP102c1854a"}]` - **`type`** `string` - **`deviceId`** `string` - **`lastSync`** `string`\ Timestamp of the last activity sync from the device - **`admin_key`** `string`\ Obfuscated admin key material. Only returned for G2 devices when `admin_key=true`/`1` is passed. - **`lockRef`** `string`\ Internal database reference of the device. Only returned when `lock_id=true`/`1` is passed. **Response body — `402`:** - **`error`** `string` **Response body — `404`:** - **`message`** `string` **Response body — `409`:** - **`message`** `string` **Example response — `200`:** ```json { "batteryLevel": 20, "deviceId": "EK1X013f300d", "deviceName": "My keypad 1", "homeId": [ "2rqQx4Riasw3Rs6db" ], "id": "2rqQx4Riasw3Rs6db01", "lastSync": "2022-05-30T00:00:00+08:00", "linkedDevices": [], "pairedAt": "2021-07-03T12:00:00+08:00", "type": "Keypad" } ``` **Example response — `402`:** ```json { "error": "30 days igloohome API trial has ended" } ``` **Example response — `404`:** ```json { "message": "not found device" } ``` **Example response — `409`:** ```json { "message": "timezone is not found on property" } ``` ## Configure Device Details `PUT` `https://api.igloohome.co/home/devices/{deviceId}` Configures device settings. The API rejects `batteryLevel` with `400` on device SKUs that don't support battery-level reporting. ### Path Parameters | Parameter | Type | Required | | --- | --- | --- | | deviceId | string | Yes | ### Body Parameters Content-Type: `application/json` - **`batteryLevel`** `integer`\ **batteryLevel** defines the level of battery detail reported by the lock. `null` is accepted and ignored: nothing is updated and `200` is returned. ### Request Example ```bash curl -X PUT "https://api.igloohome.co/home/devices/{deviceId}" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -d '{ "batteryLevel": "value" }' ``` ```go package main import ( "bytes" "fmt" "io" "net/http" ) func main() { url := "https://api.igloohome.co/home/devices/{deviceId}" payload := []byte(`{ "batteryLevel": "value" }`) req, _ := http.NewRequest("PUT", url, bytes.NewBuffer(payload)) req.Header.Set("Content-Type", "application/json") req.Header.Set("Authorization", "Bearer YOUR_ACCESS_TOKEN") req.Header.Set("Accept", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(string(body)) } ``` ```javascript const res = await fetch("https://api.igloohome.co/home/devices/{deviceId}", { method: "PUT", headers: { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json", "Content-Type": "application/json" }, body: JSON.stringify({ "batteryLevel": "value" }) }); const data = await res.json(); console.log(data); ``` ```python import requests url = "https://api.igloohome.co/home/devices/{deviceId}" headers = { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } payload = { "batteryLevel": "value" } response = requests.put(url, headers=headers, json=payload) print(response.json()) ``` ```php "https://api.igloohome.co/home/devices/{deviceId}", CURLOPT_RETURNTRANSFER => true, CURLOPT_CUSTOMREQUEST => "PUT", CURLOPT_HTTPHEADER => [ "Authorization: Bearer YOUR_ACCESS_TOKEN", "Accept: application/json", "Content-Type: application/json" ], CURLOPT_POSTFIELDS => json_encode([ "batteryLevel" => "value" ]) ]); $response = curl_exec($curl); curl_close($curl); echo $response; ``` ```kotlin val client = OkHttpClient() val mediaType = "application/json".toMediaType() val body = """ { "batteryLevel": "value" } """.trimIndent().toRequestBody(mediaType) val request = Request.Builder() .url("https://api.igloohome.co/home/devices/{deviceId}") .method("PUT", body) .addHeader("Authorization", "Bearer YOUR_ACCESS_TOKEN") .addHeader("Accept", "application/json") .addHeader("Content-Type", "application/json") .build() val response = client.newCall(request).execute() println(response.body?.string()) ``` ```swift import Foundation var request = URLRequest(url: URL(string: "https://api.igloohome.co/home/devices/{deviceId}")!) request.httpMethod = "PUT" request.setValue("Bearer YOUR_ACCESS_TOKEN", forHTTPHeaderField: "Authorization") request.setValue("application/json", forHTTPHeaderField: "Accept") request.setValue("application/json", forHTTPHeaderField: "Content-Type") let payload: [String: Any] = [ "batteryLevel": "value" ] request.httpBody = try? JSONSerialization.data(withJSONObject: payload) let task = URLSession.shared.dataTask(with: request) { data, response, error in if let data = data { print(String(data: data, encoding: .utf8) ?? "") } } task.resume() ``` ### Responses `200 Settings updated.` `400 Bad Request` `401 Unauthorized, invalid or expired authorization token` `402 Response` `403 Forbidden, accessToken scope must contain 'igloohomeapi/update-device'` `404 Not Found` `409 Conflict. The device's property record is missing a timezone (data integrity guard). '{ message: 'timezone is not found on property' }'` `415 Unsupported Media Type` `500 Internal Server Error` **Response body — `200`:** - **`message`** `string` - Example: `Successfully` **Response body — `400`:** - **`error`** `string` **Response body — `402`:** - **`error`** `string` **Response body — `404`:** - **`error`** `string` - **`message`** `string` **Response body — `409`:** - **`message`** `string` **Example response — `200`:** ```json { "message": "Successfully" } ``` **Example response — `400`:** ```json { "error": "The BatteryLevel is too high! It must be at least 100" } ``` **Example response — `402`:** ```json { "error": "30 days igloohome API trial has ended" } ``` **Example response — `404`:** ```json { "message": "not found device" } ``` **Example response — `409`:** ```json { "message": "timezone is not found on property" } ``` ## Get Device Activity Logs `GET` `https://api.igloohome.co/home/devices/{deviceId}/activity` Returns a paginated list of activity logs recorded for a device. ### Path Parameters | Parameter | Type | Required | | --- | --- | --- | | deviceId | string | Yes | ### Query Parameters - **`startDate`** `string`\ Only return activity logs on or after this date - **`endDate`** `string`\ Only return activity logs up to and including this date - **`locale`** `string`\ Locale for the human-readable `description` field. Must be one of the supported locale codes, otherwise the API returns `400`. Two of those codes (`ko`, `ru`) are accepted but not yet translated. They fall back to `en` instead of returning an error. - Default: `en` - **`limit`** `number`\ Number of objects to return, from 1 to 300. Defaults to 100. - Constraints: `>= 1`, `<= 300` - Default: `100` - Example: `30` - **`cursor`** `string`\ The pagination cursor. `cursor` is a string ID that marks your place in the list. For instance, if you make a list request and receive 100 objects, with `nextCursor` of `2sThyA1jii6WmTo3j`, your next call can include `cursor=2sThyA1jii6WmTo3j` in order to fetch the next page of the list. - **`sort`** `string`\ Order in which to return objects. Defaults to `desc`. - Default: `desc` - Allowed values: `asc`, `desc` ### Request Example ```bash curl -X GET "https://api.igloohome.co/home/devices/{deviceId}/activity?startDate=value&endDate=value&locale=value&limit=value&cursor=value&sort=value" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "Accept: application/json" ``` ```go package main import ( "fmt" "io" "net/http" ) func main() { url := "https://api.igloohome.co/home/devices/{deviceId}/activity?startDate=value&endDate=value&locale=value&limit=value&cursor=value&sort=value" req, _ := http.NewRequest("GET", url, nil) req.Header.Set("Authorization", "Bearer YOUR_ACCESS_TOKEN") req.Header.Set("Accept", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(string(body)) } ``` ```javascript const res = await fetch("https://api.igloohome.co/home/devices/{deviceId}/activity?startDate=value&endDate=value&locale=value&limit=value&cursor=value&sort=value", { method: "GET", headers: { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } }); const data = await res.json(); console.log(data); ``` ```python import requests url = "https://api.igloohome.co/home/devices/{deviceId}/activity" headers = { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } params = { "startDate": "value", "endDate": "value", "locale": "value", "limit": "value", "cursor": "value", "sort": "value" } response = requests.get(url, headers=headers, params=params) print(response.json()) ``` ```php "https://api.igloohome.co/home/devices/{deviceId}/activity?startDate=value&endDate=value&locale=value&limit=value&cursor=value&sort=value", CURLOPT_RETURNTRANSFER => true, CURLOPT_CUSTOMREQUEST => "GET", CURLOPT_HTTPHEADER => [ "Authorization: Bearer YOUR_ACCESS_TOKEN", "Accept: application/json" ] ]); $response = curl_exec($curl); curl_close($curl); echo $response; ``` ```kotlin val client = OkHttpClient() val request = Request.Builder() .url("https://api.igloohome.co/home/devices/{deviceId}/activity?startDate=value&endDate=value&locale=value&limit=value&cursor=value&sort=value") .method("GET", null) .addHeader("Authorization", "Bearer YOUR_ACCESS_TOKEN") .addHeader("Accept", "application/json") .build() val response = client.newCall(request).execute() println(response.body?.string()) ``` ```swift import Foundation var request = URLRequest(url: URL(string: "https://api.igloohome.co/home/devices/{deviceId}/activity?startDate=value&endDate=value&locale=value&limit=value&cursor=value&sort=value")!) request.httpMethod = "GET" request.setValue("Bearer YOUR_ACCESS_TOKEN", forHTTPHeaderField: "Authorization") request.setValue("application/json", forHTTPHeaderField: "Accept") let task = URLSession.shared.dataTask(with: request) { data, response, error in if let data = data { print(String(data: data, encoding: .utf8) ?? "") } } task.resume() ``` ### Responses `200 OK` `400 Bad Request. Invalid 'locale'/'limit'/'cursor'/'sort'.` `401 Unauthorized, invalid or expired authorization token` `402 Response` `403 Forbidden, accessToken scope must contain 'igloohomeapi/get-device-activity'` `404 '{ message: 'not found device' }' or '{ message: 'not found property' }'` `409 Conflict. The device's property record is missing a timezone (data integrity guard). '{ message: 'timezone is not found on property' }'` `500 Internal Server Error` **Response body — `200`:** - **`nextCursor`** `string`\ A string pointing to the next page of results. Empty string indicates you reached the end of the list - **`payload`** `array of object`\ An array containing activity log entries - **`activityType`** `string` - **`description`** `string`\ Human-readable, locale-translated description of the activity - **`activityTimeAt`** `string`\ Local time the activity occurred (alias of `localActionAt`) **Response body — `400`:** - **`error`** `string` **Response body — `402`:** - **`error`** `string` **Response body — `404`:** - **`message`** `string` **Response body — `409`:** - **`message`** `string` **Example response — `200`:** ```json { "nextCursor": "65a7d4c8b2c9f1e2d3a4b5c6", "payload": [ { "activityTimeAt": "2024-01-15T14:30:00+08:00", "activityType": "UNLOCK", "description": "Unlocked by keypad PIN" }, { "activityTimeAt": "2024-01-15T13:45:00+08:00", "activityType": "LOCK", "description": "Locked by bluetooth key" } ] } ``` **Example response — `400`:** ```json { "error": "'limit' must be between 1 to 300 inclusive" } ``` **Example response — `402`:** ```json { "error": "30 days igloohome API trial has ended" } ``` **Example response — `404`:** ```json { "message": "not found device" } ``` **Example response — `409`:** ```json { "message": "timezone is not found on property" } ``` ## Push Device Activity Logs `POST` `https://api.igloohome.co/home/devices/{deviceId}/activity` Ingests raw activity logs synced off a device (e.g. by a bridge or app). Each item in `logsPayload` is a JSON-serialized log entry. ### Path Parameters | Parameter | Type | Required | | --- | --- | --- | | deviceId | string | Yes | ### Body Parameters Content-Type: `application/json` - **`logsPayload`** `array of string` *required*\ Array of JSON-serialized log entry strings, each with `log` and `bluetoothDeviceName` fields ### Request Example ```bash curl -X POST "https://api.igloohome.co/home/devices/{deviceId}/activity" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -d '{ "logsPayload": "value" }' ``` ```go package main import ( "bytes" "fmt" "io" "net/http" ) func main() { url := "https://api.igloohome.co/home/devices/{deviceId}/activity" payload := []byte(`{ "logsPayload": "value" }`) req, _ := http.NewRequest("POST", url, bytes.NewBuffer(payload)) req.Header.Set("Content-Type", "application/json") req.Header.Set("Authorization", "Bearer YOUR_ACCESS_TOKEN") req.Header.Set("Accept", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(string(body)) } ``` ```javascript const res = await fetch("https://api.igloohome.co/home/devices/{deviceId}/activity", { method: "POST", headers: { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json", "Content-Type": "application/json" }, body: JSON.stringify({ "logsPayload": "value" }) }); const data = await res.json(); console.log(data); ``` ```python import requests url = "https://api.igloohome.co/home/devices/{deviceId}/activity" headers = { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } payload = { "logsPayload": "value" } response = requests.post(url, headers=headers, json=payload) print(response.json()) ``` ```php "https://api.igloohome.co/home/devices/{deviceId}/activity", CURLOPT_RETURNTRANSFER => true, CURLOPT_CUSTOMREQUEST => "POST", CURLOPT_HTTPHEADER => [ "Authorization: Bearer YOUR_ACCESS_TOKEN", "Accept: application/json", "Content-Type: application/json" ], CURLOPT_POSTFIELDS => json_encode([ "logsPayload" => "value" ]) ]); $response = curl_exec($curl); curl_close($curl); echo $response; ``` ```kotlin val client = OkHttpClient() val mediaType = "application/json".toMediaType() val body = """ { "logsPayload": "value" } """.trimIndent().toRequestBody(mediaType) val request = Request.Builder() .url("https://api.igloohome.co/home/devices/{deviceId}/activity") .method("POST", body) .addHeader("Authorization", "Bearer YOUR_ACCESS_TOKEN") .addHeader("Accept", "application/json") .addHeader("Content-Type", "application/json") .build() val response = client.newCall(request).execute() println(response.body?.string()) ``` ```swift import Foundation var request = URLRequest(url: URL(string: "https://api.igloohome.co/home/devices/{deviceId}/activity")!) request.httpMethod = "POST" request.setValue("Bearer YOUR_ACCESS_TOKEN", forHTTPHeaderField: "Authorization") request.setValue("application/json", forHTTPHeaderField: "Accept") request.setValue("application/json", forHTTPHeaderField: "Content-Type") let payload: [String: Any] = [ "logsPayload": "value" ] request.httpBody = try? JSONSerialization.data(withJSONObject: payload) let task = URLSession.shared.dataTask(with: request) { data, response, error in if let data = data { print(String(data: data, encoding: .utf8) ?? "") } } task.resume() ``` ### Responses `200 OK` `400 '{ error: "\"logsPayload\" is required" }'` `401 Unauthorized, invalid or expired authorization token` `402 Response` `403 Forbidden, accessToken scope must contain 'igloohomeapi/store-device-activity'` `404 '{ message: 'not found device' }' or '{ message: 'not found property' }'` `409 Conflict. The device's property record is missing a timezone (data integrity guard). '{ message: 'timezone is not found on property' }'` `415 Unsupported Media Type` `500 Internal Server Error` **Response body — `200`:** - **`message`** `string` - Example: `Successfully.` **Response body — `400`:** - **`error`** `string` **Response body — `402`:** - **`error`** `string` **Response body — `404`:** - **`message`** `string` **Response body — `409`:** - **`message`** `string` **Example response — `200`:** ```json { "message": "Successfully." } ``` **Example response — `400`:** ```json { "error": "\"logsPayload\" is required" } ``` **Example response — `402`:** ```json { "error": "30 days igloohome API trial has ended" } ``` **Example response — `404`:** ```json { "message": "not found device" } ``` **Example response — `409`:** ```json { "message": "timezone is not found on property" } ``` ## Get Master PIN `GET` `https://api.igloohome.co/home/devices/{deviceId}/masterpin` Returns the master pin of the given device. Supports `lock` and `keypad` devices only. |Device Type| |--| |Lock| |Keypad| ### Path Parameters | Parameter | Type | Required | | --- | --- | --- | | deviceId | string | Yes | ### Request Example ```bash curl -X GET "https://api.igloohome.co/home/devices/{deviceId}/masterpin" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "Accept: application/json" ``` ```go package main import ( "fmt" "io" "net/http" ) func main() { url := "https://api.igloohome.co/home/devices/{deviceId}/masterpin" req, _ := http.NewRequest("GET", url, nil) req.Header.Set("Authorization", "Bearer YOUR_ACCESS_TOKEN") req.Header.Set("Accept", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(string(body)) } ``` ```javascript const res = await fetch("https://api.igloohome.co/home/devices/{deviceId}/masterpin", { method: "GET", headers: { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } }); const data = await res.json(); console.log(data); ``` ```python import requests url = "https://api.igloohome.co/home/devices/{deviceId}/masterpin" headers = { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } response = requests.get(url, headers=headers) print(response.json()) ``` ```php "https://api.igloohome.co/home/devices/{deviceId}/masterpin", CURLOPT_RETURNTRANSFER => true, CURLOPT_CUSTOMREQUEST => "GET", CURLOPT_HTTPHEADER => [ "Authorization: Bearer YOUR_ACCESS_TOKEN", "Accept: application/json" ] ]); $response = curl_exec($curl); curl_close($curl); echo $response; ``` ```kotlin val client = OkHttpClient() val request = Request.Builder() .url("https://api.igloohome.co/home/devices/{deviceId}/masterpin") .method("GET", null) .addHeader("Authorization", "Bearer YOUR_ACCESS_TOKEN") .addHeader("Accept", "application/json") .build() val response = client.newCall(request).execute() println(response.body?.string()) ``` ```swift import Foundation var request = URLRequest(url: URL(string: "https://api.igloohome.co/home/devices/{deviceId}/masterpin")!) request.httpMethod = "GET" request.setValue("Bearer YOUR_ACCESS_TOKEN", forHTTPHeaderField: "Authorization") request.setValue("application/json", forHTTPHeaderField: "Accept") let task = URLSession.shared.dataTask(with: request) { data, response, error in if let data = data { print(String(data: data, encoding: .utf8) ?? "") } } task.resume() ``` ### Responses `200 OK` `401 Unauthorized, invalid or expired authorization token` `402 Response` `403 Forbidden, accessToken scope must contain 'igloohomeapi/get-master-pin'` `404 '{ message: 'not found device' }' or '{ message: 'not found property' }'` `409 Conflict. The device's property record is missing a timezone (data integrity guard). '{ message: 'timezone is not found on property' }'` `500 Internal Server Error` **Response body — `200`:** - **`pin`** `string`\ Master pin - Example: `49667198` **Response body — `402`:** - **`error`** `string` **Response body — `404`:** - **`message`** `string` **Response body — `409`:** - **`message`** `string` **Example response — `200`:** ```json { "pin": "49667198" } ``` **Example response — `402`:** ```json { "error": "30 days igloohome API trial has ended" } ``` **Example response — `404`:** ```json { "message": "not found device" } ``` **Example response — `409`:** ```json { "message": "timezone is not found on property" } ``` ### FILE: home/api_jobs Title: Jobs Category: API Reference ---------------------------------------- # Jobs API Reference API endpoints for managing jobs. ## Lock Jobs Bridge Proxied Jobs send commands to smart locks through a Bridge device. The Bridge acts as an intermediary that communicates with locks via Bluetooth while your application communicates with the Bridge via the API. Send these jobs with [Create a Bridge Proxied Job](#create-a-bridge-proxied-job). ### Job Creation Create a job by making a `POST` request to: `/devices/{deviceId}/jobs/bridges/{bridgeId}` **Request Parameters** | Parameter | Type | Description | | --- | --- | --- | | jobType | number | Command type identifier (see Job Types) | | jobData | object | Command-specific parameters | **Response** ```json { "jobId": "string" } ``` **Job Types** | Job Type | ID | | --- | --- | | Lock | 1 | | Unlock | 2 | | Create Custom PIN code | 4 | | Delete PIN code | 5 | | Get Battery Level | 9 | | Get Device Status | 10 | | Get Activity Logs | 15 | ### Command Details #### Lock Locks the device and optionally synchronizes its internal clock. | Parameter | Type | Description | Required | | --- | --- | --- | --- | | lockTime | ISO_DATE | Synchronize the lock's clock | No | ```json { "jobType": 1, "jobData": { "lockTime": "2024-01-01T12:00:00+00:00" } } ``` #### Unlock Unlocks the device and optionally synchronizes its internal clock. | Parameter | Type | Description | Required | | --- | --- | --- | --- | | lockTime | ISO_DATE | Synchronize the lock's clock | No | ```json { "jobType": 2, "jobData": { "lockTime": "2024-01-01T12:00:00+00:00" } } ``` #### Create Custom PIN Code Creates a PIN code with specific access permissions and time restrictions. Devices/locks supporting PIN are listed in [Supported Devices](/home/supported-devices). | Parameter | Type | Description | Required | | --- | --- | --- | --- | | accessName | string | Display name for the PIN code, up to 60 characters | Yes | | pin | string | 4-6 digit PIN code | Yes | | pinType | number | PIN type (see table below) | Yes | | startDate | string | When PIN becomes active (ISO_DATE format) | Yes | | endDate | string | When PIN expires (ISO_DATE format) | Duration only | **PIN Types** | Type | ID | Description | | --- | --- | --- | | One-Time | 1 | Valid for 24 hours from start date | | Permanent | 2 | Valid indefinitely from start date | | Duration | 4 | Valid between start and end dates | ```json { "jobType": 4, "jobData": { "accessName": "Guest PIN", "pin": "123456", "pinType": 4, "startDate": "2024-01-01T12:00:00+00:00", "endDate": "2024-01-01T16:00:00+00:00" } } ``` One-Time PIN (24-hour validity): ```json { "jobType": 4, "jobData": { "accessName": "OTP PIN", "pin": "123456", "pinType": 1, "startDate": "2024-01-01T00:00:00+00:00" } } ``` #### Delete PIN Code Removes a PIN code from the lock. An unactivated AlgoPIN with a start date more than 256 hours after its creation cannot be deleted. | Parameter | Type | Description | Required | | --- | --- | --- | --- | | pin | string | PIN code to be deleted, 4-9 digits | Yes | ```json { "jobType": 5, "jobData": { "pin": "123456" } } ``` #### Get Battery Level Retrieves the lock's current battery level as a percentage. ```json { "jobType": 9 } ``` #### Get Device Status Queries the lock's current operational status. ```json { "jobType": 10 } ``` #### Get Activity Logs Downloads activity logs from the lock. Optionally synchronizes the lock's clock. Activity logs are deleted from the lock after retrieval. | Parameter | Type | Description | Required | | --- | --- | --- | --- | | lockTime | ISO_DATE | Synchronize the lock's clock | No | ```json { "jobType": 15, "jobData": { "lockTime": "2024-01-01T12:00:00+00:00" } } ``` ### Error Status Codes | Status Code | Description | Applies To | | --- | --- | --- | | 400 | Request validation failed, e.g. `job type not supported. see documentation for supported job type(s)` or `pin type not supported. see documentation for supported pin type(s)` | All | | 401 | Missing, invalid or expired access token | All | | 402 | The igloohome API trial has ended, or the billing grace period has expired | All | | 403 | The token lacks the scope for this job type | All | | 404 | Bridge or device not found | All | | 406 | `PIN (123456) is already taken. Please try a different pin` | Create Custom PIN code | | 406 | `Lock is not linked to bridge` | All | | 406 | `Unable to contact bridge as it appears to be offline` | All | | 415 | Missing `Content-Type: application/json` | All | | 500 | Unexpected server error | All | ## Bridge Jobs These jobs target the Bridge device itself, not a lock. Send these jobs with [Create a Bridge Targeted Job](#create-a-bridge-targeted-job). ### Job Creation Create a job by making a `POST` request to: `/devices/{bridgeId}/jobs` `bridgeId` is the Bridge's device ID. | Parameter | Type | | --- | --- | | jobType | integer, see Job Types for a full list | ```json { "jobType": 10 } ``` **Response** ```json { "jobId": "string" } ``` **Job Types** | Job Type | Number | | --- | --- | | Get Device Status | 10 | ### Job Details #### Get Device Status (Bridge Diagnostic) ```json { "jobType": 10 } ``` Once the job completes, you receive a webhook with the result. See [Get Device Status](/home/bridge-events#get-device-status) for the payload. **Rate limit:** one Get Device Status job per bridge every 5 minutes per user. Further requests return `429` with a `Retry-After` header (seconds). ### Error Status Codes | Status Code | Message (API Response) | Description | Applies To | | --- | --- | --- | --- | | 400 | Bad Request | The request was unacceptable, often due to a missing or invalid parameter (e.g., `` is required). | All | | 401 | Unauthorized | No valid API key or access token was provided in the request header. | All | | 402 | Payment Required (Various Messages) | The API trial has ended or the payment method was declined. Please verify billing details. | All | | 403 | Forbidden | The authenticated user does not have the necessary permissions (scopes) for this resource. | All | | 404 | Not Found | The requested resource does not exist or the endpoint URL is incorrect. | All | | 405 | Method Not Allowed | The HTTP method used is not supported by this endpoint. | All | | 406 | Unable to contact bridge as it appears to be offline | Unable to contact the bridge. Ensure the physical hardware is powered on and connected. | All | | 415 | Unsupported Media Type | The Content-Type header must be set to application/json. | N/A | | 429 | Too many requests. Please try again after X seconds. | Rate limit exceeded: one job per bridge every 5 minutes per user. Wait for the `Retry-After` seconds. | All | | 500 | Internal Server Error | An unexpected error occurred on our end. Please retry later or contact support. | All | ## Create a Bridge Targeted Job `POST` `https://api.igloohome.co/home/devices/{bridgeId}/jobs` Creates a job that targets a Bridge device directly, not a lock via a bridge. Supports only `jobType` 10 (Get Device Status). Rate limit: one `GET_DEVICE_STATUS` job per bridge every 5 minutes per user (except for internal igloohome accounts). ### Path Parameters | Parameter | Type | Required | | --- | --- | --- | | bridgeId | string | Yes | ### Body Parameters Content-Type: `application/json` - **`jobType`** `integer` *required*\ 10 = Get Device Status. The only supported value. - Allowed values: `10` ### Request Example ```bash curl -X POST "https://api.igloohome.co/home/devices/{bridgeId}/jobs" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -d '{ "jobType": "value" }' ``` ```go package main import ( "bytes" "fmt" "io" "net/http" ) func main() { url := "https://api.igloohome.co/home/devices/{bridgeId}/jobs" payload := []byte(`{ "jobType": "value" }`) req, _ := http.NewRequest("POST", url, bytes.NewBuffer(payload)) req.Header.Set("Content-Type", "application/json") req.Header.Set("Authorization", "Bearer YOUR_ACCESS_TOKEN") req.Header.Set("Accept", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(string(body)) } ``` ```javascript const res = await fetch("https://api.igloohome.co/home/devices/{bridgeId}/jobs", { method: "POST", headers: { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json", "Content-Type": "application/json" }, body: JSON.stringify({ "jobType": "value" }) }); const data = await res.json(); console.log(data); ``` ```python import requests url = "https://api.igloohome.co/home/devices/{bridgeId}/jobs" headers = { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } payload = { "jobType": "value" } response = requests.post(url, headers=headers, json=payload) print(response.json()) ``` ```php "https://api.igloohome.co/home/devices/{bridgeId}/jobs", CURLOPT_RETURNTRANSFER => true, CURLOPT_CUSTOMREQUEST => "POST", CURLOPT_HTTPHEADER => [ "Authorization: Bearer YOUR_ACCESS_TOKEN", "Accept: application/json", "Content-Type: application/json" ], CURLOPT_POSTFIELDS => json_encode([ "jobType" => "value" ]) ]); $response = curl_exec($curl); curl_close($curl); echo $response; ``` ```kotlin val client = OkHttpClient() val mediaType = "application/json".toMediaType() val body = """ { "jobType": "value" } """.trimIndent().toRequestBody(mediaType) val request = Request.Builder() .url("https://api.igloohome.co/home/devices/{bridgeId}/jobs") .method("POST", body) .addHeader("Authorization", "Bearer YOUR_ACCESS_TOKEN") .addHeader("Accept", "application/json") .addHeader("Content-Type", "application/json") .build() val response = client.newCall(request).execute() println(response.body?.string()) ``` ```swift import Foundation var request = URLRequest(url: URL(string: "https://api.igloohome.co/home/devices/{bridgeId}/jobs")!) request.httpMethod = "POST" request.setValue("Bearer YOUR_ACCESS_TOKEN", forHTTPHeaderField: "Authorization") request.setValue("application/json", forHTTPHeaderField: "Accept") request.setValue("application/json", forHTTPHeaderField: "Content-Type") let payload: [String: Any] = [ "jobType": "value" ] request.httpBody = try? JSONSerialization.data(withJSONObject: payload) let task = URLSession.shared.dataTask(with: request) { data, response, error in if let data = data { print(String(data: data, encoding: .utf8) ?? "") } } task.resume() ``` ### Responses `200 OK` `400 Bad Request` `401 Unauthorized, invalid or expired authorization token` `402 Response` `403 Forbidden, accessToken scope must contain 'igloohomeapi/get-device-status-bridge-proxied-job'` `404 Bridge Not Found` `406 '{ error: 'Unable to contact bridge as it appears to be offline' }'` `415 Unsupported Media Type` `429 Too Many Requests. '{ error: 'Too many requests. Please try again after N seconds.' }'. The response includes a 'Retry-After' header (seconds).` `500 Internal Server Error` **Response body — `200`:** - **`jobId`** `string` **Response body — `400`:** - **`error`** `string` **Response body — `402`:** - **`error`** `string` **Response body — `406`:** - **`error`** `string` **Response body — `429`:** - **`error`** `string` **Example response — `200`:** ```json { "jobId": "6345191a82bcfc12a921bdb6" } ``` **Example response — `400`:** ```json { "error": "job type not supported. see documentation for supported job type(s)" } ``` **Example response — `402`:** ```json { "error": "30 days igloohome API trial has ended" } ``` **Example response — `406`:** ```json { "error": "Unable to contact bridge as it appears to be offline" } ``` **Example response — `429`:** ```json { "error": "Too many requests. Please try again after 45 seconds." } ``` ## Create a Bridge Proxied Job `POST` `https://api.igloohome.co/home/devices/{deviceId}/jobs/bridges/{bridgeId}` Creates a job for a lock via a Bridge device. #### Supported Job Types |Job Type|Number| |--|--| |Lock|1| |Unlock|2| |Create Custom PIN code (duration) |4| |Delete PIN code|5| |Get Battery Level|9| |Get Device Status|10| |Get Activity Logs|15| `jobData` is only required for `jobType` 4 (Create Custom PIN code) and 5 (Delete PIN code). |jobType|Required jobData fields| |--|--| |4 (Create Custom PIN code)|`accessName`, `pin`, `pinType`, `startDate`, and `endDate` (only when `pinType` is 4/DURATION)| |5 (Delete PIN code)|`pin` only| ### Path Parameters | Parameter | Type | Required | | --- | --- | --- | | deviceId | string | Yes | | bridgeId | string | Yes | ### Body Parameters Content-Type: `application/json` - **`jobType`** `integer` *required*\ See the job type table above - Allowed values: `1`, `2`, `4`, `5`, `9`, `10`, `15` - **`jobData`** `object`\ Shape depends on `jobType`. See the table above. Omit for jobTypes other than 4 and 5. - **`accessName`** `string`\ Required when `jobType` is 4 (Create Custom PIN code). - **`pinType`** `integer`\ 1 = One-Time, 2 = Permanent, 4 = Duration. Required when `jobType` is 4. - Allowed values: `1`, `2`, `4` - **`pin`** `string`\ 4-6 digits when `jobType` is 4 (Create Custom PIN code); 4-9 digits when `jobType` is 5 (Delete PIN code). - **`startDate`** `string`\ Required when `jobType` is 4. Must be in format `YYYY-MM-DDTHH:mm:ss+hh:mm`. - **`endDate`** `string`\ Required when `jobType` is 4 and `pinType` is 4 (Duration). Must be in format `YYYY-MM-DDTHH:mm:ss+hh:mm` and after `startDate`. ### Request Example ```bash curl -X POST "https://api.igloohome.co/home/devices/{deviceId}/jobs/bridges/{bridgeId}" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -d '{ "jobData": "value", "jobType": "value" }' ``` ```go package main import ( "bytes" "fmt" "io" "net/http" ) func main() { url := "https://api.igloohome.co/home/devices/{deviceId}/jobs/bridges/{bridgeId}" payload := []byte(`{ "jobData": "value", "jobType": "value" }`) req, _ := http.NewRequest("POST", url, bytes.NewBuffer(payload)) req.Header.Set("Content-Type", "application/json") req.Header.Set("Authorization", "Bearer YOUR_ACCESS_TOKEN") req.Header.Set("Accept", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(string(body)) } ``` ```javascript const res = await fetch("https://api.igloohome.co/home/devices/{deviceId}/jobs/bridges/{bridgeId}", { method: "POST", headers: { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json", "Content-Type": "application/json" }, body: JSON.stringify({ "jobData": "value", "jobType": "value" }) }); const data = await res.json(); console.log(data); ``` ```python import requests url = "https://api.igloohome.co/home/devices/{deviceId}/jobs/bridges/{bridgeId}" headers = { "Authorization": "Bearer YOUR_ACCESS_TOKEN", "Accept": "application/json" } payload = { "jobData": "value", "jobType": "value" } response = requests.post(url, headers=headers, json=payload) print(response.json()) ``` ```php "https://api.igloohome.co/home/devices/{deviceId}/jobs/bridges/{bridgeId}", CURLOPT_RETURNTRANSFER => true, CURLOPT_CUSTOMREQUEST => "POST", CURLOPT_HTTPHEADER => [ "Authorization: Bearer YOUR_ACCESS_TOKEN", "Accept: application/json", "Content-Type: application/json" ], CURLOPT_POSTFIELDS => json_encode([ "jobData" => "value", "jobType" => "value" ]) ]); $response = curl_exec($curl); curl_close($curl); echo $response; ``` ```kotlin val client = OkHttpClient() val mediaType = "application/json".toMediaType() val body = """ { "jobData": "value", "jobType": "value" } """.trimIndent().toRequestBody(mediaType) val request = Request.Builder() .url("https://api.igloohome.co/home/devices/{deviceId}/jobs/bridges/{bridgeId}") .method("POST", body) .addHeader("Authorization", "Bearer YOUR_ACCESS_TOKEN") .addHeader("Accept", "application/json") .addHeader("Content-Type", "application/json") .build() val response = client.newCall(request).execute() println(response.body?.string()) ``` ```swift import Foundation var request = URLRequest(url: URL(string: "https://api.igloohome.co/home/devices/{deviceId}/jobs/bridges/{bridgeId}")!) request.httpMethod = "POST" request.setValue("Bearer YOUR_ACCESS_TOKEN", forHTTPHeaderField: "Authorization") request.setValue("application/json", forHTTPHeaderField: "Accept") request.setValue("application/json", forHTTPHeaderField: "Content-Type") let payload: [String: Any] = [ "jobData": "value", "jobType": "value" ] request.httpBody = try? JSONSerialization.data(withJSONObject: payload) let task = URLSession.shared.dataTask(with: request) { data, response, error in if let data = data { print(String(data: data, encoding: .utf8) ?? "") } } task.resume() ``` ### Responses `200 Job Created` `400 Bad Request` `401 Unauthorized, invalid or expired authorization token` `402 Response` `403 Forbidden, accessToken scope must contain the scope for the given 'jobType' (see table below)` `404 Bridge or Device Not Found` `406 Not Acceptable` `415 Unsupported Media Type` `500 Internal Server Error` **Response body — `200`:** - **`jobId`** `string` **Response body — `400`:** - **`error`** `string` **Response body — `402`:** - **`error`** `string` **Response body — `406`:** - **`error`** `string` **Example response — `200`:** ```json { "jobId": "6345191a82bcfc12a921bdb6" } ``` **Example response — `400`:** ```json { "error": "job type not supported. see documentation for supported job type(s)" } ``` **Example response — `402`:** ```json { "error": "30 days igloohome API trial has ended" } ``` **Example response — `406`:** ```json { "error": "Unable to contact bridge as it appears to be offline" } ``` ## Get Job Status `GET` `https://api.igloohome.co/home/jobs/{jobId}` Returns the status of a job you created earlier. ### Path Parameters | Parameter | Type | Required | | --- | --- | --- | | jobId | string | Yes |
[...]
